# Main 50 Mhz CPLD clock and virtual clock
create_clock -name clk -period 20.000 -waveform {0 10} [get_ports {clk}]
create_clock -name vclk_ext -period 20.000 -waveform {0 10}

# create all other clocks
create_clock -name HSMA_CLK_IN0_3B -period 20.000 -waveform {0 10} [get_ports {HSMA_CLK_IN0_3B}]
create_clock -name HSMA_CLK_OUT_5B -period 20.000 -waveform {0 10} [get_ports {HSMA_CLK_OUT_5B}]
create_clock -name VID_DISP_PCLK -period 30.000 -waveform {0 15} [get_ports {VID_DISP_PCLK}]
create_clock -name VID_TX_PCLK -period 15.000 -waveform {0 7.5} [get_ports {VID_TX_PCLK}]
create_clock -name AUD_TX_ACLK -period 10.000 -waveform {0 5} [get_ports {AUD_TX_ACLK}]
create_clock -name VID_RX_PCLK -period 10.000 -waveform {0 5} [get_ports {VID_RX_PCLK}]
create_clock -name AUD_RX_ACLK -period 10.000 -waveform {0 5} [get_ports {AUD_RX_ACLK}]
create_clock -name EX2_CLK -period 20.000 -waveform {0 10} [get_ports {EX2_CLK}]

set_input_delay -clock vclk_fpga_vid_in -min -3.75 [get_ports hsmc_tx_vid]
set_input_delay -add_delay -clock vclk_fpga_vid_in -min -7.5 [get_ports hsmc_tx_vid]
set_input_delay -clock vclk_fpga_vid_in -max 3.75 [get_ports hsmc_tx_vid]
set_input_delay -add_delay -clock vclk_fpga_vid_in -max 7.5 [get_ports hsmc_tx_vid]

set_output_delay -clock vclk_vid_disp_pclk -min -7.5 [get_ports VID_DISP_*]
set_output_delay -clock vclk_vid_disp_pclk -max 7.5 [get_ports VID_DISP_*]

set_output_delay -clock vclk_vid_tx_pclk -min -3.75 [get_ports VID_TX_*]
set_output_delay -clock vclk_vid_tx_pclk -max 3.75 [get_ports VID_TX_*]

set_false_path -from [get_clocks *] -to [get_clocks *]
set_max_delay -from [get_ports *] -to [get_ports *] 12
