module debounce (reset, clk, noisy, clean);
	input reset, clk, noisy;
	output clean;
	
	parameter NDELAY = 650000;
	parameter NBITS = 20;
	
	reg [NBITS-1:0] count;
	reg xnew, clean, stop;
	
	always @ (posedge clk)
	begin
		if (reset == 1'b0) begin xnew <= noisy; clean <= noisy; count <= 1'b0; stop <= 1'b1; end
		else if (noisy != xnew) begin xnew <= noisy; count <= 1'b0; stop <= 1'b0; end

// toggles the state of the output once per button press
		else if (count == NDELAY && stop == 1'b0)
		begin
			if (xnew == 1'b0) begin clean <= ~clean; stop <= 1'b1; end
			else stop <= 1'b1;
		end
		
		else if (stop == 1'b0) count <= count + 1;
		else count <= 1'b0;
	end
endmodule